<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 12/18/2008 *
 * ================                             Last change: 11/01/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-network.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Generic (sponsor) network connection extension   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Allgemeine Werbenetzwerk-Erweiterung             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.0');

// Version history array (add more with , '0.1.0' and so on)
setExtensionVersionHistory(array('0.0'));

// This extension is in development (non-productive)
enableExtensionProductive(false);

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running (modules.php?module=admin is called)
		// Main table which hold
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_data`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_data` (
`network_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_short_name` VARCHAR(50) NOT NULL DEFAULT '',
`network_title` VARCHAR(255) NOT NULL DEFAULT '',
`network_reflink` VARCHAR(255) NOT NULL DEFAULT '',
`network_data_seperator` CHAR(4) NOT NULL DEFAULT '|',
`network_row_seperator` CHAR(4) NOT NULL DEFAULT '|',
`network_request_type` ENUM('GET','POST') NOT NULL DEFAULT 'GET',
`network_charset` VARCHAR(20) NOT NULL DEFAULT 'UTF-8',
UNIQUE (`network_short_name`),
PRIMARY KEY (`network_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Network data'");

		// Types the network provider is supporting (e.g. Forced-Banner and so on)
		// @TODO network_type_name is an internal name and needs documentation
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_types`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_types` (
`network_type_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_type_name` VARCHAR(255) NOT NULL DEFAULT '',
`network_type_title` VARCHAR(255) NOT NULL DEFAULT '',
`network_type_request_url` VARCHAR(255) NOT NULL DEFAULT '',
`network_type_click_url` VARCHAR(255) NOT NULL DEFAULT '',
`network_type_banner_url` VARCHAR(255) NOT NULL DEFAULT '',
UNIQUE `provider_type` (`network_id`,`network_type_name`),
PRIMARY KEY (`network_type_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Types provideable by networks. ONLY FILL OUT WITH PROPER idEA!'");

		// HTTP parameters (names) for URLs
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_request_params`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_request_params` (
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`request_param_max_reload_time` VARCHAR(10) NOT NULL DEFAULT 'reload',
`request_param_min_waiting_time` VARCHAR(10) NOT NULL DEFAULT 'ma',
`request_param_min_remain_clicks` VARCHAR(10) NOT NULL DEFAULT 'uebrig',
`request_param_min_payment` VARCHAR(10) NOT NULL DEFAULT 'verguetung',
`request_param_allow_erotic` VARCHAR(10) NOT NULL DEFAULT 'erotik',
PRIMARY KEY (`network_type_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Request parameters for GET/POST request ONLY FILL OUT WITH PROPER idEA!'");

		// Error status codes
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_type_codes`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_type_codes` (
`network_type_code_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_type_code_value` VARCHAR(50) NOT NULL DEFAULT '',
`network_type_code_type` VARCHAR(100) NOT NULL DEFAULT 'INVALID_TYPE',
UNIQUE `code_type` (`network_type_code_value`,`network_type_id`),
INDEX (`network_type_id`),
PRIMARY KEY (`network_type_code_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Error codes for all types'");

		// Code types (internal table)
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_codes`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_codes` (
`network_code_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_code` VARCHAR(100) NOT NULL DEFAULT 'INVALID_CODE',
UNIQUE (`network_code`),
PRIMARY KEY (`network_code_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Error types, generic data, DO NOT ALTER!'");

		// Valid translation keys (we hate hard-coded arrays, you see?)
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_translations`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_translations` (
`network_translate_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_translation` VARCHAR(100) NOT NULL DEFAULT '',
UNIQUE `type_trans` (`network_type_id`,`network_translation`),
PRIMARY KEY (`network_translate_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Translations for array keys, generic data, DO NOT ALTER!'");

		// Array-Element translation tables per type/provider
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_array_translation`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_array_translation` (
`network_translate_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_array_key` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 0,
`network_translation` VARCHAR(100) NOT NULL DEFAULT '',
UNIQUE `provider_type_key` (`network_id`,`network_type_id`,`network_array_key`),
UNIQUE `provider_type_trans` (`network_id`,`network_type_id`,`network_translation`),
PRIMARY KEY (`network_translate_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Cache for all queried APIs'");

		// Data from the webmaster (you!)
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_config`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_config` (
`network_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_affiliate_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_api_password` VARCHAR(255) NOT NULL DEFAULT '',
`network_site_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_query_amount` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
UNIQUE `network_affiliate` (`network_id`,`network_affiliate_id`),
UNIQUE `affiliate_site` (`network_affiliate_id`,`network_site_id`),
PRIMARY KEY (`network_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Configuration data from the webmaster (you!)'");

		// Configuration data for e.g. reload-time
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_types_config`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_types_config` (
`network_data_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`max_reload_time` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`min_waiting_time` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`min_remain_clicks` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`min_payment` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000,
`allow_erotic` VARCHAR(10) NOT NULL DEFAULT '',
UNIQUE `provider_type` (`network_id`,`network_type_id`),
PRIMARY KEY (`network_data_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Configuration data for every type (e.g. reload-time)'");

		// Cache for queried APIs. Re-check depends on config
		// `network_cache_refresh` in seconds or if set to zero, full day
		// divided by query amount.
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_cache`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_cache` (
`network_cache_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_cache_data` MEDIUMBLOB,
`network_cache_timestamp` TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00',
UNIQUE `provider_type` (`network_id`,`network_type_id`),
PRIMARY KEY (`network_cache_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Cache for all queried APIs'");

		// Reload locks for several types
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_reloads`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_network_reloads` (
`network_reload_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`network_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_reload_lock` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 0,
`network_inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP(),
UNIQUE `provider_type` (`network_id`,`network_type_id`),
PRIMARY KEY (`network_reload_id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Reload locks'");

		// Insert error code types
		// - Affiliate id or interface password wrong
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('AFF_ID_PASS_WRONG')");
		// - Webmaster's site id is not assigned (invalid, different affiliate id)
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('SITE_ID_NOT_ASSIGNED')");
		// - Webmaster's site id is locked
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('SITE_ID_LOCKED')");
		// - General error in interface data
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('INTERFACE_DATA_ERROR')");
		// - Request amount depleted
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('REQUESTS_DEPLETED')");
		// - No campaigns found for given criteria (but maybe there are with more widen criteria)
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('NO_CAMPAIGNS_FOUND')");
		// - No campaigns found with allowed interface output (but there are maybe non-interface campaigns)
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('NO_CAMPAIGNS_FOUND_INTERFACE')");
		// - Webmaster's site id is not unlocked for choosen type
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('SITE_ID_NOT_ALLOWED_TYPE')");
		// - Request parameters incomplete
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_codes` (`network_code`) VALUES ('REQUEST_PARAMS_INCOMPLETE')");

		// Sponsor networks
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_network_data` (`network_short_name`, `network_title`, `network_reflink`, `network_data_seperator`, `network_row_seperator`, `network_request_type`, `network_charset`) VALUES ('yoomedia', 'Yoo!Media Solutions', 'http://www.yoomedia.de?ref=1715', '|', '|', 'GET', 'WINDOWS-1252')");
		
		// Admin menu entries
		addAdminMenuSql('network',NULL,'Werbenetzwerke','Verwalten Sie hier Werbenetzwerke (API-Anbindung), versenden Sie deren Mails, oder &uuml;bernehmen Sie deren Textlinks und vieles mehr. <strong>VORSICHT:</strong> Das Einrichten von weiteren Werbenetzwerken ist nicht leicht, daf&uuml;r aber sehr flexibel! Sollte ein Netzwerk fehlen, so melden Sie dies bitte <a href="http://forum.mxchange.org/topic-462.html" target="_blank" title="Direktlink zum Forum">im Forum</a>!',4);
		addAdminMenuSql('network','config_networks','API-Daten','Stellen Sie Ihre Affiliate- Webseiten-Id und API-Passwort ein. Diese erhalten Sie zu &uuml;ber 99% aus dem jeweiligen Zugangsbereich des Anbieters. Sollten Sie bei einem Netzwerk noch nicht angemeldet sein, verwenden Sie bitte meinen Referal-Link.',1);
		addAdminMenuSql('network','config_network_types','Werbearten','Stellen Sie hier Reload-Zeiten, Mindestauffenthalt und so weiter pro Werbeart und Werbenetzwerk ein. Es werden sonst Standart-Werte (Mimimumwerte: 0, Maximumwerte: sehr gross, Erotik: aus) angenommen, die Sie meistens nicht wollen.',2);
		addAdminMenuSql('network','query_networks','APIs abfragen','Fragt alle eingestellten APIs ab. Die Ergebnisse werden dann f&uuml;r einen einstellbaren Zeitraum gecacht und nicht erneut angefordert.',3);
		addAdminMenuSql('network','config_network','Einstellungen','Stellen Sie generelle Einstellungen ein, die f&uuml;r alle Werbenetzwerke gelten, wie z.B. Cache-Erneuerungsinterval. Generell sind aber die Einstellungen in Ordnung, da z.B. sonst Ihre freien Abfragen beim Werbenetzwerk sich zu schnell abbauen.',4);
		addAdminMenuSql('network','list_network_reloads','Reload-Sperren','Listen oder l&ouml;schen Sie hier Reload-Sperren. <strong>Vorsicht:</strong> Die hier gespeicherten Reload-Sperren sind vom jeweiligen Werbenetzwerk &uuml;bernommen. Eventuell verdienen Sie nichts, wenn Sie z.B. eine Mail innerhalb der Reload-Sperre erneut versenden.',5);
		addAdminMenuSql('network','list_networks','Auflisten/Verwalten','<strong>Experten-Einstellungen!</strong> Hier &auml;ndern Sie die Einstellungen an den Grunddaten (Stammdaten) des jeweiligen Werbenetzwerks ab. Sie sollten hier generell nichts einstellen und <a href="http://forum.mxchange.org/forum-43.html" target="_blank" title="Direktlink zum Forum">im Forum</a> um Hilfe fragen, wenn Sie selber ein Werbenetzwerk einrichten m&ouml;chten.',6);
		addAdminMenuSql('network','list_network_types','Werbearten','<strong>Experten-Einstellungen!</strong> Hier &auml;ndern Sie die Einstellungen zu den Werbearten pro Werbenetzwerken. Sie sollten hier generell nichts einstellen und <a href="http://forum.mxchange.org/forum-43.html" target="_blank" title="Direktlink zum Forum">im Forum</a> um Hilfe fragen, wenn Sie selber ein Werbenetzwerk einrichten m&ouml;chten.',7);
		addAdminMenuSql('network','list_network_params','Abfrageparameter','<strong>Experten-Einstellungen!</strong> Hier stellen Sie die Abfrageparameter (wie sie genannt werden m&uuml;ssen, um das API-Script korrekt aufrufen zu k&ouml;nnen) ein, pro Werbenetzwerk. Sie sollten hier generell nichts einstellen und <a href="http://forum.mxchange.org/forum-43.html" target="_blank" title="Direktlink zum Forum">im Forum</a> um Hilfe fragen, wenn Sie selber ein Werbenetzwerk einrichten m&ouml;chten.',8);
		addAdminMenuSql('network','list_network_code_types','R&uuml;ckgabewerte','<strong>Experten-Einstellungen!</strong> Hier stellen Sie die R&uuml;ckgabewerte ein, die im Falle eines Fehlers pro API-Script kommen k&ouml;nnen. Sie sollten hier generell nichts einstellen und <a href="http://forum.mxchange.org/forum-43.html" target="_blank" title="Direktlink zum Forum">im Forum</a> um Hilfe fragen, wenn Sie selber ein Werbenetzwerk einrichten m&ouml;chten.',9);
		addAdminMenuSql('network','list_network_codes','Fehlercodes','<strong>Experten-Einstellungen!</strong> Hier stellen Sie die Namen von Fehlercodes ein, die Scripte zur&uuml;ckliefern k&ouml;nnen. <strong>Dies sind INTERNE Daten und sollten nur vom Entwicklerteam angepasst werden.</strong> Stellen Sie an diesen Einstellungen bitte nichts um. Sie sollten hier generell nichts einstellen und <a href="http://forum.mxchange.org/forum-43.html" target="_blank" title="Direktlink zum Forum">im Forum</a> um Hilfe fragen, wenn Sie selber ein Werbenetzwerk einrichten m&ouml;chten.',10);

		// Configuration entries
		addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `network_cache_refresh` BIGINT(20) UNSIGNED NOT NULL DEFAULT ' . (60 * 15) . '');
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_data`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_types`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_request_params`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_type_codes`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_translations`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_array_translation`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_config`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_types_config`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_cache`');
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_network_reloads`');

		// Admin menu
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='network'");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql('');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes('');
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown extension mode %s detected.", getExtensionMode()));
		break;
} // END - switch

// [EOF]
?>
