<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/31/2003 *
 * ===================                          Last change: 11/23/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : admin-inc.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Administrative related functions                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Fuer die Administration benoetigte Funktionen    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Register an administrator account
function addAdminAccount ($user, $md5, $email) {
	// Login does already exist
	$ret = 'already';

	// Lookup the admin
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `login`='%s' LIMIT 1",
		array($user), __FUNCTION__, __LINE__);

	// Is the entry there?
	if (SQL_NUMROWS($result) == '0') {
		// Ok, let's create the admin login
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_admins` (`login`, `password`, `email`) VALUES ('%s', '%s', '%s')",
			array(
				$user,
				$md5,
				$email
			), __FUNCTION__, __LINE__);

		// All done
		$ret = 'done';
	} // END - if

	// Free memory
	SQL_FREERESULT($result);

	// Return result
	return $ret;
}

// Only be executed on login procedure!
function ifAdminLoginDataIsValid ($admin, $password) {
	// By default no admin is found
	$ret = '404';

	// Get admin id
	$adminId = getAdminId($admin);

	// Init array with admin id by default
	$data = array('admin_id' => $adminId);

	// Is the cache valid?
	if (isAdminHashSet($admin)) {
		// Get password from cache
		$data['password'] = getAdminHash($admin);
		$ret = 'pass';
		incrementStatsEntry('cache_hits');

		// Include more admins data?
		if ((isExtensionInstalledAndNewer('admins', '0.7.2')) && (isset($GLOBALS['cache_array']['admin']['login_failures'][$adminId]))) {
			// Load them here
			$data['login_failures'] = $GLOBALS['cache_array']['admin']['login_failures'][$adminId];
			$data['last_failure']   = $GLOBALS['cache_array']['admin']['last_failure'][$adminId];
		} // END - if
	} elseif (!isExtensionActive('cache')) {
		// Add extra data via filter now
		$add = runFilterChain('sql_admin_extra_data');

		// Get password from DB
		$result = SQL_QUERY_ESC("SELECT `password`" . $add . " FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
			array($adminId), __FUNCTION__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result) == 1) {
			// Login password found
			$ret = 'pass';

			// Fetch data
			$data = SQL_FETCHARRAY($result);
		} // END - if

		// Free result
		SQL_FREERESULT($result);
	}

	//* DEBUG: */ outputHtml('*' . $data['password'] . '/' . md5($password) .'/' . $ret . '*<br />');
	if ((isset($data['password'])) && (strlen($data['password']) == 32) && ($data['password'] == md5($password))) {
		// Generate new hash
		$data['password'] = generateHash($password);

		// Is the sql_patches not installed, than we cannot have a valid hashed password here!
		//* DEBUG: */ outputHtml($ret . ',' . intval(isExtensionInstalledAndOlder('sql_patches', '0.3.6')) . '/' . intval(!isExtensionInstalled('sql_patches')).'<br />');
		if (($ret == 'pass') && ((isExtensionInstalledAndOlder('sql_patches', '0.3.6')) || (!isExtensionInstalled('sql_patches')))) $ret = 'done';
	} elseif ((isExtensionInstalledAndOlder('sql_patches', '0.3.6')) || (!isExtensionInstalled('sql_patches'))) {
		// Old hashing way
		return $ret;
	} elseif (!isset($data['password'])) {
		// Password not found, so no valid login!
		return $ret;
	}

	// Generate salt of password
	$salt = substr($data['password'], 0, -40);

	// Check if password is same
	//* DEBUG: */ outputHtml('*' . $ret . ',' . $data['password'] . ',' . $password . ',' . $salt . '*<br />');
	if (($ret == 'pass') && ($data['password'] == generateHash($password, $salt)) && ((!empty($salt))) || ($data['password'] == md5($password))) {
		// Re-hash the plain passord with new random salt
		$data['password'] = generateHash($password);

		// Do we have 0.7.0 of admins or later?
		// Remmeber login failures if available
		if ((isExtensionInstalledAndNewer('admins', '0.7.2')) && (isset($data['login_failures']))) {
			// Store it in session
			setSession('mxchange_admin_failures', $data['login_failures']);
			setSession('mxchange_admin_last_fail', $data['last_failure']);

			// Update password and reset login failures
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins` SET `password`='%s',`login_failures`=0,`last_failure`='0000-00-00 00:00:00' WHERE `id`=%s LIMIT 1",
				array($data['password'], $adminId), __FUNCTION__, __LINE__);
		} else {
			// Update password
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins` SET `password`='%s' WHERE `id`=%s LIMIT 1",
				array($data['password'], $adminId), __FUNCTION__, __LINE__);
		}

		// Rebuild cache
		rebuildCacheFile('admin', 'admin');

		// Login has failed by default... ;-)
		$ret = 'failed1';

		// Password matches so login here
		if (doAdminLogin($admin, $data['password'])) {
			// All done now
			$ret = 'done';
		} // END - if
	} elseif ((empty($salt)) && ($ret == 'pass')) {
		// Something bad went wrong
		$ret = 'failed_salt';
	} elseif ($ret == 'done') {
		// Try to login here if we have the old hashing way (sql_patches not installed?)
		if (!doAdminLogin($admin, $data['password'])) {
			// Something went wrong
			$ret = 'failed2';
		} // END - if
	}

	// Count login failure if admins extension version is 0.7.0+
	if (($ret == 'pass') && (getExtensionVersion('admins') >= '0.7.0')) {
		// Update counter
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins` SET login_failures`=`login_failures`+1,`last_failure`=NOW() WHERE `id`=%s LIMIT 1",
			array($adminId), __FUNCTION__, __LINE__);

		// Rebuild cache
		rebuildCacheFile('admin', 'admin');
	} // END - if

	// Return the result
	//* DEBUG: */ die('RETURN=' . $ret);
	return $ret;
}

// Try to login the admin by setting some session/cookie variables
function doAdminLogin ($adminLogin, $passHash) {
	// Reset failure counter on matching admins version
	if ((isExtensionInstalledAndNewer('admins', '0.7.0')) && ((isExtensionOlder('sql_patches', '0.3.6')) || (!isExtensionInstalled('sql_patches')))) {
		// Reset counter on out-dated sql_patches version
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins` SET `login_failures`=0, `last_failure`='0000-00-00 00:00:00' WHERE `login`='%s' LIMIT 1",
			array($adminLogin), __FUNCTION__, __LINE__);

		// Rebuild cache
		rebuildCacheFile('admin', 'admin');
	} // END - if

	// Now set all session variables and return the result
	return ((
		setSession('admin_md5', generatePassString($passHash))
	) && (
		setSession('admin_login', $adminLogin)
	) && (
		setSession('admin_last', time())
	));
}

// Only be executed on cookie checking
function ifAdminCookiesAreValid ($admin, $password) {
	// By default no admin cookies are found
	$ret  = '404';
	$pass = '';

	// Get hash
	$pass = getAdminHash($admin);
	if ($pass != '-1') $ret = 'pass';

	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):".generatePassString($pass).'('.strlen($pass).")/".$password.'('.strlen($password).")<br />");

	// Check if password matches
	if (($ret == 'pass') && ((generatePassString($pass) == $password) || ($pass == $password) || ((strlen($pass) == 32) && (md5($password) == $pass))) && (isAdmin())) {
		// Passwords matches!
		$ret = 'done';
	} // END - if

	// Return result
	return $ret;
}

// Do an admin action
function doAdminAction () {
	// Get default what
	$what = getWhat();

	//* DEBUG: */ outputHtml(__LINE__."*".$what.'/'.getModule().'/'.getAction().'/'.getWhat()."*<br />");

	// Remove any spaces from variable
	if (empty($what)) {
		// Default admin action is the overview page
		$what = 'overview';
	} else {
		// Secure it
		$what = secureString($what);
	}

	// Get action value
	$action = getModeAction(getModule(), $what);

	// Define admin login name and id number
	$content['login'] = getSession('admin_login');
	$content['id']    = getCurrentAdminId();

	// Preload templates
	if (isExtensionActive('admins')) {
		$content['welcome'] = loadTemplate('admin_welcome_admins', true, $content);
	} else {
		$content['welcome'] = loadTemplate('admin_welcome', true, $content);
	}
	$content['footer'] = loadTemplate('admin_footer' , true, $content);
	$content['menu']   = addAdminMenu($action, $what, true);

	// Tableset header
	loadTemplate('admin_main_header', false, $content);

	// Check if action/what pair is valid
	$result_action = SQL_QUERY_ESC("SELECT
	`id`
FROM
	`{?_MYSQL_PREFIX?}_admin_menu`
WHERE
	`action`='%s' AND
	(
		(
			`what`='%s' AND `what` != 'overview'
		) OR (
			(
				`what`='' OR `what` IS NULL
			) AND (
				'%s'='overview'
			)
		)
	)
LIMIT 1",
		array(
			$action,
			$what,
			$what
		), __FUNCTION__, __LINE__);

	// Do we have an entry?
	if (SQL_NUMROWS($result_action) == 1) {
		// Is valid but does the inlcude file exists?
		$inc = sprintf("inc/modules/admin/action-%s.php", $action);
		if ((isIncludeReadable($inc)) && (isMenuActionValid('admin', $action, $what)) && ($GLOBALS['acl_allow'] === true)) {
			// Ok, we finally load the admin action module
			loadInclude($inc);
		} elseif ($GLOBALS['acl_allow'] === false) {
			// Access denied
			loadTemplate('admin_menu_failed', false, sprintf(getMessage('ADMIN_ACCESS_DENIED'), $what));
		} else {
			// Include file not found! :-(
			loadTemplate('admin_menu_failed', false, sprintf(getMessage('ADMIN_ACTION_404'), $action));
		}
	} else {
		// Invalid action/what pair found!
		loadTemplate('admin_menu_failed', false, sprintf(getMessage('ADMIN_ACTION_INVALID'), $action . '/' . $what));
	}

	// Free memory
	SQL_FREERESULT($result_action);

	// Tableset footer
	loadTemplate('admin_main_footer', false, $content);
}

// Adds an admin menu
function addAdminMenu ($action, $what, $return=false) {
	// Init variables
	$SUB = false;
	$OUT = '';

	// Menu descriptions
	$GLOBALS['menu']['description'] = array();
	$GLOBALS['menu']['title'] = array();

	// Build main menu
	$result_main = SQL_QUERY("SELECT
	`action`, `title`, `descr`
FROM
	`{?_MYSQL_PREFIX?}_admin_menu`
WHERE
	(`what`='' OR `what` IS NULL)
ORDER BY
	`sort` ASC,
	`id` DESC", __FUNCTION__, __LINE__);

	// Do we have entries?
	if (SQL_NUMROWS($result_main) > 0) {
		$OUT  = '<div style="height:7px" class="seperator">&nbsp;</div>';
		$OUT .= '<ul class="admin_menu_main">';
		// @TODO Rewrite this to $content = SQL_FETCHARRAY()
		while (list($menu, $title, $descr) = SQL_FETCHROW($result_main)) {
			if ((isExtensionActive('admins')) && (getExtensionVersion('admins') > '0.2.0')) {
				$ACL = adminsCheckAdminAcl($menu, '');
			} else {
				// @TODO ACL is 'allow'... hmmm
				$ACL = true;
			}

			// Filename
			$inc = sprintf("inc/modules/admin/action-%s.php", $menu);

			// Is the file readable?
			$readable = isIncludeReadable($inc);

			if ($ACL === true) {
				if ($SUB === false) {
					// Insert compiled menu title and description
					$GLOBALS['menu']['title'][$menu]      = $title;
					$GLOBALS['menu']['description'][$menu] = $descr;
				}
				$OUT .= '<li class="admin_menu">
<div class="nobr"><strong>&middot;</strong>&nbsp;';

				if ($readable === true) {
					if (($menu == $action) && (empty($what))) {
						$OUT .= '<strong>';
					} else {
						$OUT .= '[<a href="{?URL?}/modules.php?module=admin&amp;action=' . $menu . '">';
					}
				} else {
					$OUT .= '<em style="cursor:help" class="admin_note" title="{--MENU_ACTION_404--}">';
				}

				$OUT .= $title;

				if ($readable === true) {
					if (($menu == $action) && (empty($what))) {
						$OUT .= '</strong>';
					} else {
						$OUT .= '</a>]';
					}
				} else {
					$OUT .= '</em>';
				}

				$OUT .= '</div>
</li>';

				// Check for menu entries
				$result_what = SQL_QUERY_ESC("SELECT
	`what`, `title`, `descr`
FROM
	`{?_MYSQL_PREFIX?}_admin_menu`
WHERE
	`action`='%s' AND
	`what` != '' AND
	`what` IS NOT NULL
ORDER BY
	`sort` ASC,
	`id` DESC",
					array($menu), __FUNCTION__, __LINE__);

				// Remember the count for later checks
				setAdminMenuHasEntries($menu, ((SQL_NUMROWS($result_what) > 0) && ($action == $menu)));

				// Do we have entries?
				if ((ifAdminMenuHasEntries($menu)) && (SQL_NUMROWS($result_what) > 0)) {
					$GLOBALS['menu']['description'] = array();
					$GLOBALS['menu']['title'] = array(); $SUB = true;
					$OUT .= '<li class="admin_menu_sub"><ul class="admin_menu_sub">';
					// @TODO Rewrite this to $content = SQL_FETCHARRAY()
					while (list($what_sub, $title_what, $desc_what) = SQL_FETCHROW($result_what)) {
						// Check for access level
						if ((isExtensionActive('admins')) && (getExtensionVersion('admins') > '0.2.0')) {
							$ACL = adminsCheckAdminAcl('', $what_sub);
						} else {
							// @TODO ACL is 'allow'... hmmm
							$ACL = true;
						}

						// Filename
						$inc = sprintf("inc/modules/admin/what-%s.php", $what_sub);

						// Is the file readable?
						$readable = isIncludeReadable($inc);

						// Access allowed?
						if ($ACL === true) {
							// Insert compiled title and description
							$GLOBALS['menu']['title'][$what_sub]      = $title_what;
							$GLOBALS['menu']['description'][$what_sub] = $desc_what;
							$OUT .= '<li class="admin_menu">
<div class="nobr"><strong>--&gt;</strong>&nbsp;';
							if ($readable === true) {
								if ($what == $what_sub) {
									$OUT .= '<strong>';
								} else {
									$OUT .= '[<a href="{?URL?}/modules.php?module=admin&amp;what=' . $what_sub . '">';
								}
							} else {
								$OUT .= '<em style="cursor:help" class="admin_note" title="{--MENU_WHAT_404--}">';
							}

							$OUT .= $title_what;

							if ($readable === true) {
								if ($what == $what_sub) {
									$OUT .= '</strong>';
								} else {
									$OUT .= '</a>]';
								}
							} else {
								$OUT .= '</em>';
							}
							$OUT .= '</div>
</li>';
						} // END - if
					} // END - while

					// Free memory
					SQL_FREERESULT($result_what);
					$OUT .= '</ul>
</li>';
				} // END - if

				$OUT .= '<li style="height:7px" class="seperator">&nbsp;</li>';
			} // END - if
		} // END - while

		// Free memory
		SQL_FREERESULT($result_main);
		$OUT .= '</ul>';
	}

	// Is there a cache instance again?
	// Return or output content?
	if ($return === true) {
		return $OUT;
	} else {
		outputHtml($OUT);
	}
}

// Create member selection box
function addMemberSelectionBox ($def=0, $add_all=false, $return=false, $none=false, $field='userid') {
	// Output selection form with all confirmed user accounts listed
	$result = SQL_QUERY("SELECT `userid`, `surname`, `family` FROM `{?_MYSQL_PREFIX?}_user_data` ORDER BY `userid` ASC", __FUNCTION__, __LINE__);

	// Default output
	$OUT = '';

	// USe this only for adding points (e.g. adding refs really makes no sence ;-) )
	if ($add_all === true)   $OUT = '      <option value="all">{--ALL_MEMBERS--}</option>';
	 elseif ($none === true) $OUT = '      <option value="0">{--SELECT_NONE--}</option>';

	while ($content = SQL_FETCHARRAY($result)) {
		$OUT .= '      <option value="' . bigintval($content['userid']) . '"';
		if ($def == $content['userid']) $OUT .= ' selected="selected"';
		$OUT .= '>' . $content['surname'] . ' ' . $content['family'] . ' (' . bigintval($content['userid']) . ')</option>';
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	if ($return === false) {
		// Remeber options in constant
		$content['member_selection'] = $OUT;
		$content['what']             = getWhat();

		// Load template
		loadTemplate('admin_member_selection_box', false, $content);
	} else {
		// Return content in selection frame
		return '<select class="admin_select" name="' . $field . '" size="1">' . $OUT . '</select>';
	}
}

// Create a menu selection box for given menu system
// @TODO Try to rewrite this to adminAddMenuSelectionBox()
// @DEPRECATED
function adminMenuSelectionBox_DEPRECATED ($mode, $default = '', $defid = '') {
	$what = "`what` != ''";
	if ($mode == 'action') $what = "(`what`='' OR `what` IS NULL) AND action !='login'";
	$result = SQL_QUERY_ESC("SELECT %s, `title` FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE ".$what." ORDER BY `sort` ASC",
		array($mode), __FUNCTION__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Load menu as selection
		$OUT = "<select name=\"".$mode."_menu";
		if ((!empty($defid)) || ($defid == '0')) $OUT .= "[".$defid."]";
		$OUT .= "\" size=\"1\" class=\"admin_select\">
	<option value=\"\">{--SELECT_NONE--}</option>\n";
		// @TODO Try to rewrite this to $content = SQL_FETCHARRAY(). Please look some lines above for the dynamic query
		while (list($menu, $title) = SQL_FETCHROW($result)) {
			$OUT .= "  <option value=\"".$menu."\"";
			if ((!empty($default)) && ($default == $menu)) $OUT .= ' selected="selected"';
			$OUT .= ">".$title."</option>\n";
		} // END - while

		// Free memory
		SQL_FREERESULT($result);
		$OUT .= "</select>\n";
	} else {
		// No menus???
		$OUT = getMessage('ADMIN_PROBLEM_NO_MENU');
	}

	// Return output
	return $OUT;
}

// Wrapper for $_POST and adminSaveSettings
function adminSaveSettingsFromPostData ($tableName = '_config', $whereStatement = '`config`=0', $translateComma = array(), $alwaysAdd = false) {
	// Get the array
	$postData = postRequestArray();

	// Call the lower function
	adminSaveSettings($postData, $tableName, $whereStatement, $translateComma, $alwaysAdd);
}

// Save settings to the database
function adminSaveSettings (&$postData, $tableName = '_config', $whereStatement = '`config`=0', $translateComma = array(), $alwaysAdd = false) {
	// Prepare all arrays, variables
	$DATA = array();
	$skip = false;

	// Now, walk through all entries and prepare them for saving
	foreach ($postData as $id => $val) {
		// Process only formular field but not submit buttons ;)
		if ($id != 'ok') {
			// Do not save the ok value
			convertSelectionsToTimestamp($postData, $DATA, $id, $skip);

			// Shall we process this id? It muss not be empty, of course
			if (($skip === false) && (!empty($id)) && (!isset($GLOBALS['skip_config'][$id]))) {
				// Translate the value? (comma to dot!)
				if ((is_array($translateComma)) && (in_array($id, $translateComma))) {
					// Then do it here... :)
					$val = convertCommaToDot($val);
				} // END - if

				// Shall we add numbers or strings?
				$test = (float)$val;
				if ('' . $val . '' == '' . $test . '') {
					// Add numbers
					$DATA[] = sprintf("`%s`=%s", $id, $test);
				} else {
					// Add strings
					$DATA[] = sprintf("`%s`='%s'", $id, trim($val));
				}

				// Do not add a config entry twice
				$GLOBALS['skip_config'][$id] = true;

				// Update current configuration
				setConfigEntry($id, $val);
			} // END - if
		} // END - if
	} // END - foreach

	// Check if entry does exist
	$result = false;
	if ($alwaysAdd === false) {
		if (!empty($whereStatement)) {
			$result = SQL_QUERY("SELECT * FROM `{?_MYSQL_PREFIX?}".$tableName."` WHERE ".$whereStatement." LIMIT 1", __FUNCTION__, __LINE__);
		} else {
			$result = SQL_QUERY("SELECT * FROM `{?_MYSQL_PREFIX?}".$tableName."` LIMIT 1", __FUNCTION__, __LINE__);
		}
	} // END - if

	if (SQL_NUMROWS($result) == 1) {
		// "Implode" all data to single string
		$DATA_UPDATE = implode(', ', $DATA);

		// Generate SQL string
		$sql = sprintf("UPDATE `{?_MYSQL_PREFIX?}%s` SET %s WHERE %s LIMIT 1",
			$tableName,
			$DATA_UPDATE,
			$whereStatement
		);
	} else {
		// Add Line (does only work with auto_increment!
		$KEYs = array(); $values = array();
		foreach ($DATA as $entry) {
			// Split up
			$line = explode('=', $entry);
			$KEYs[] = $line[0]; $values[] = $line[1];
		} // END - foreach

		// Add both in one line
		$KEYs = implode('`, `', $KEYs);
		$values = implode(', ', $values);

		// Generate SQL string
		$sql = sprintf("INSERT INTO `{?_MYSQL_PREFIX?}%s` (%s) VALUES (%s)",
			$tableName,
			$KEYs,
			$values
		);
	}

	// Free memory
	SQL_FREERESULT($result);

	// Simply run generated SQL string
	SQL_QUERY($sql, __FUNCTION__, __LINE__);

	// Rebuild cache
	rebuildCacheFile('config', 'config');

	// Settings saved
	loadTemplate('admin_settings_saved', false, getMessage('SETTINGS_SAVED'));
}

// Generate a selection box
function adminAddMenuSelectionBox ($menu, $type, $name, $default = '') {
	// Open the requested menu directory
	$menuArray = getArrayFromDirectory(sprintf("inc/modules/%s/", $menu), '', false, false);

	// Init the selection box
	$OUT = "<select name=\"".$name."\" class=\"admin_select\" size=\"1\">
	<option value=\"\">{--IS_TOP_MENU--}</option>\n";

	// Walk through all files
	foreach ($menuArray as $file) {
		// Is this a PHP script?
		if ((!isDirectory($file)) && (strpos($file, "".$type.'-') > -1) && (strpos($file, '.php') > 0)) {
			// Then test if the file is readable
			$test = sprintf("inc/modules/%s/%s", $menu, $file);

			// Is the file there?
			if (isIncludeReadable($test)) {
				// Extract the value for what=xxx
				$part = substr($file, (strlen($type) + 1));
				$part = substr($part, 0, -4);

				// Is that part different from the overview?
				if ($part != 'overview') {
					$OUT .= "	<option value=\"".$part."\"";
					if ($part == $default) $OUT .= ' selected="selected"';
					$OUT .= ">".$part."</option>\n";
				} // END - if
			} // END - if
		} // END - if
	} // END - foreach

	// Close selection box
	$OUT .= "</select>\n";

	// Return contents
	return $OUT;
}

// Creates a user-profile link for the admin. This function can also be used for many other purposes
function generateUserProfileLink ($userid, $title = '', $what = 'list_user') {
	if (($title == '') && ($userid > 0)) {
		// Set userid as title
		$title = $userid;
	} // END - if

	if (($title == '0') && ($what == 'list_refs')) {
		// Return title again
		return $title;
	} elseif (isExtensionActive('nickname')) {
		// Get nickname
		$nick = getNickname($userid);

		// Is it not empty, use it as title else the userid
		if (!empty($nick)) $title = $nick . '(' . $userid . ')'; else $title = $userid;
	}

	// Return link
	return '[<a href="{?URL?}/modules.php?module=admin&amp;what=' . $what . '&amp;userid=' . $userid . '" title="{--ADMIN_USER_PROFILE_TITLE--}">' . $title . '</a>]';
}

// Check "logical-area-mode"
function adminGetMenuMode () {
	// Set the global mode as the mode for all admins
	$mode = getConfig('admin_menu');
	$ADMIN = $mode;

	// Get admin id
	$adminId = getCurrentAdminId();

	// Check individual settings of current admin
	if (isset($GLOBALS['cache_array']['admin']['la_mode'][$adminId])) {
		// Load from cache
		$ADMIN = $GLOBALS['cache_array']['admin']['la_mode'][$adminId];
		incrementStatsEntry('cache_hits');
	} elseif (isExtensionInstalledAndNewer('admins', '0.6.7')) {
		// Load from database when version of 'admins' is enough
		$result = SQL_QUERY_ESC("SELECT la_mode FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
			array($adminId), __FUNCTION__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Load data
			list($ADMIN) = SQL_FETCHROW($result);
		}

		// Free memory
		SQL_FREERESULT($result);
	}

	// Check what the admin wants and set it when it's not the global mode
	if ($ADMIN != 'global') $mode = $ADMIN;

	// Return admin-menu's mode
	return $mode;
}

// Change activation status
function adminChangeActivationStatus ($IDs, $table, $row, $idRow = 'id') {
	$cnt = '0'; $newStatus = 'Y';
	if ((is_array($IDs)) && (count($IDs) > 0)) {
		// "Walk" all through and count them
		foreach ($IDs as $id => $selected) {
			// Secure the id number
			$id = bigintval($id);

			// Should always be set... ;-)
			if (!empty($selected)) {
				// Determine new status
				$result = SQL_QUERY_ESC("SELECT %s FROM `{?_MYSQL_PREFIX?}_%s` WHERE %s=%s LIMIT 1",
				array($row, $table, $idRow, $id), __FUNCTION__, __LINE__);

				// Row found?
				if (SQL_NUMROWS($result) == 1) {
					// Load the status
					list($currStatus) = SQL_FETCHROW($result);

					// And switch it N<->Y
					if ($currStatus == 'Y') $newStatus = 'N'; else $newStatus = 'Y';

					// Change this status
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_%s` SET %s='%s' WHERE %s=%s LIMIT 1",
					array($table, $row, $newStatus, $idRow, $id), __FUNCTION__, __LINE__);

					// Count up affected rows
					$cnt += SQL_AFFECTEDROWS();
				} // END - if

				// Free the result
				SQL_FREERESULT($result);
			} // END - if
		} // END - foreach

		// Output status
		loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_STATUS_CHANGED'), $cnt, count($IDs)));
	} else {
		// Nothing selected!
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_NOTHING_SELECTED_CHANGE'));
	}
}

// Send mails for del/edit/lock build modes
function sendAdminBuildMails ($mode, $table, $content, $id, $subjectPart = '') {
	// Default subject is the subject part
	$subject = $subjectPart;

	// Is the subject part not set?
	if (empty($subjectPart)) {
		// Then use it from the mode
		$subject = strtoupper($mode);
	} // END - if

	// Is the raw userid set?
	if (postRequestElement('userid_raw', $id) > 0) {
		// Generate subject
		$subjectLine = getMessage('MEMBER_'.strtoupper($subject).'_'.strtoupper($table).'_SUBJECT');

		// Load email template
		if (!empty($subjectPart)) {
			$mail = loadEmailTemplate('member_' . $mode . '_' . strtolower($subjectPart) . '_' . $table, $content);
		} else {
			$mail = loadEmailTemplate('member_' . $mode . '_' . $table, $content);
		}

		// Send email out
		sendEmail(postRequestElement('userid_raw', $id), $subjectLine, $mail);
	} // END - if

	// Generate subject
	$subjectLine = getMessage('ADMIN_'.strtoupper($subject).'_'.strtoupper($table).'_SUBJECT');

	// Send admin notification out
	if (!empty($subjectPart)) {
		sendAdminNotification($subjectLine, 'admin_' . $mode . '_' . strtolower($subjectPart) . '_' . $table, $content, postRequestElement('userid_raw', $id));
	} else {
		sendAdminNotification($subjectLine, 'admin_' . $mode . '_' . $table, $content, postRequestElement('userid_raw', $id));
	}
}

// Build a special template list
function adminListBuilder ($listType, $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn) {
	$OUT = ''; $SW = 2;

	// "Walk" through all entries
	foreach ($IDs as $id => $selected) {
		// Secure id number
		$id = bigintval($id);

		// Get result from a given column array and table name
		$result = SQL_RESULT_FROM_ARRAY($table, $columns, $idColumn, $id, __FUNCTION__, __LINE__);

		// Is there one entry?
		if (SQL_NUMROWS($result) == 1) {
			// Load all data
			$content = SQL_FETCHARRAY($result);

			// Filter all data
			foreach ($content as $key => $value) {
				// Search index
				$idx = array_search($key, $columns, true);

				// Do we have a userid?
				if ($key == 'userid') {
					// Add it again as raw id
					$content['userid'] = bigintval($value);
				} // END - if

				// Handle the call in external function
				$content[$key] = handleExtraValues($filterFunctions[$idx], $value, $extraValues[$idx]);
			} // END - foreach

			// Add color switching
			$content['sw'] = $SW;

			// Then list it
			$OUT .= loadTemplate(sprintf("admin_%s_%s_row",
			$listType,
			$table
			), true, $content
			);

			// Switch color
			$SW = 3 - $SW;
		} // END - if

		// Free the result
		SQL_FREERESULT($result);
	} // END - foreach

	// Load master template
	loadTemplate(sprintf("admin_%s_%s",
	$listType,
	$table
	), false, $OUT
	);
}

// Change status of "build" list
function adminBuilderStatusHandler ($mode, $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn, $statusArray) {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues)) && (count($statusArray) > 0)) {
		// "Walk" through all entries
		foreach ($IDs as $id => $sel) {
			// Construct SQL query
			$sql = sprintf("UPDATE `{?_MYSQL_PREFIX?}_%s` SET", SQL_ESCAPE($table));

			// Load data of entry
			$result = SQL_QUERY_ESC("SELECT * FROM `{?_MYSQL_PREFIX?}_%s` WHERE %s=%s LIMIT 1",
				array($table, $idColumn, $id), __FUNCTION__, __LINE__);

			// Fetch the data
			$content = SQL_FETCHARRAY($result);

			// Free the result
			SQL_FREERESULT($result);

			// Add all status entries (e.g. status column last_updated or so)
			$newStatus = 'UNKNOWN';
			$oldStatus = 'UNKNOWN';
			$statusColumn = 'unknown';
			foreach ($statusArray as $column => $statusInfo) {
				// Does the entry exist?
				if ((isset($content[$column])) && (isset($statusInfo[$content[$column]]))) {
					// Add these entries for update
					$sql .= sprintf(" %s='%s',", SQL_ESCAPE($column), SQL_ESCAPE($statusInfo[$content[$column]]));

					// Remember status
					if ($statusColumn == 'unknown') {
						// Always (!!!) change status column first!
						$oldStatus = $content[$column];
						$newStatus = $statusInfo[$oldStatus];
						$statusColumn = $column;
					} // END - if
				} elseif (isset($content[$column])) {
					// Unfinished!
					app_die(__FUNCTION__, __LINE__, ":UNFINISHED: id={$id}/{$column}[".gettype($statusInfo)."] = {$content[$column]}");
				}
			} // END - foreach

			// Add other columns as well
			foreach (postRequestArray() as $key => $entries) {
				// Skip id, raw userid and 'do_$mode'
				if (!in_array($key, array($idColumn, 'userid_raw', ('do_'.$mode)))) {
					// Are there brackets () at the end?
					if (substr($entries[$id], -2, 2) == "()") {
						// Direct SQL command found
						$sql .= sprintf(" %s=%s,", SQL_ESCAPE($key), SQL_ESCAPE($entries[$id]));
					} else {
						// Add regular entry
						$sql .= sprintf(" %s='%s',", SQL_ESCAPE($key), SQL_ESCAPE($entries[$id]));

						// Add entry
						$content[$key] = $entries[$id];
					}
				} // END - if
			} // END - foreach

			// Finish SQL statement
			$sql = substr($sql, 0, -1) . sprintf(" WHERE `%s`=%s AND `%s`='%s' LIMIT 1",
				$idColumn,
				bigintval($id),
				$statusColumn,
				$oldStatus
			);

			// Run the SQL
			SQL_QUERY($sql, __FUNCTION__, __LINE__);

			// Do we have an URL?
			if (isset($content['url'])) {
				// Then add a framekiller test as well
				$content['frametester'] = generateFrametesterUrl($content['url']);
			} // END - if

			// Send "build mails" out
			sendAdminBuildMails($mode, $table, $content, $id, $statusInfo[$content[$column]]);
		} // END - foreach
	} // END - if
}

// Delete rows by given id numbers
function adminDeleteEntriesConfirm ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $deleteNow=false, $idColumn='id', $userIdColumn='userid') {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues))) {
		// Shall we delete here or list for deletion?
		if ($deleteNow === true) {
			// The base SQL command:
			$sql = "DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_%s` WHERE %s IN (%s)";

			// Delete them all
			$idList = '';
			foreach ($IDs as $id => $sel) {
				// Is there a userid?
				if (isPostRequestElementSet('userid_raw', $id)) {
					// Load all data from that id
					$result = SQL_QUERY_ESC("SELECT * FROM `{?_MYSQL_PREFIX?}_%s` WHERE %s=%s LIMIT 1",
					array($table, $idColumn, $id), __FUNCTION__, __LINE__);

					// Fetch the data
					$content = SQL_FETCHARRAY($result);

					// Free the result
					SQL_FREERESULT($result);

					// Send "build mails" out
					sendAdminBuildMails('del', $table, $content, $id);
				} // END - if

				// Add id number
				$idList .= $id . ',';
			} // END - foreach

			// Run the query
			SQL_QUERY($sql, array($table, $idColumn, substr($idList, 0, -1)), __FUNCTION__, __LINE__);

			// Was this fine?
			if (SQL_AFFECTEDROWS() == count($IDs)) {
				// All deleted
				loadTemplate('admin_settings_saved', false, getMessage('ADMIN_ALL_ENTRIES_REMOVED'));
			} else {
				// Some are still there :(
				loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_SOME_ENTRIES_NOT_DELETED'), SQL_AFFECTEDROWS(), count($IDs)));
			}
		} else {
			// List for deletion confirmation
			adminListBuilder('del', $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}

// Edit rows by given id numbers
function adminEditEntriesConfirm ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $editNow=false, $idColumn='id', $userIdColumn='userid') {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues))) {
		// Shall we change here or list for editing?
		if ($editNow === true) {
			// Change them all
			$affected = '0';
			foreach ($IDs as $id => $sel) {
				// Prepare content array (new values)
				$content = array();

				// Prepare SQL for this row
				$sql = sprintf("UPDATE `{?_MYSQL_PREFIX?}_%s` SET",
					SQL_ESCAPE($table)
				);
				foreach (postRequestArray() as $key => $entries) {
					// Skip raw userid which is always invalid
					if ($key == 'userid_raw') {
						// Continue with next field
						continue;
					} // END - if

					// Is entries an array?
					if (($key != $idColumn) && (is_array($entries)) && (isset($entries[$id]))) {
						// Add this entry to content
						$content[$key] = $entries[$id];

						// Send data through the filter function if found
						if ((isset($filterFunctions[$key])) && (isset($extraValues[$key]))) {
							// Filter function set!
							$entries[$id] = handleExtraValues($filterFunctions[$key], $entries[$id], $extraValues[$key]);
						} // END - if

						// Then add this value
						$sql .= sprintf(" `%s`='%s',",
						SQL_ESCAPE($key),
						SQL_ESCAPE($entries[$id])
						);
					} elseif (($key != $idColumn) && (!is_array($entries))) {
						// Add normal entries as well!
						$content[$key] =  $entries;
					}

					// Do we have an URL?
					if ($key == 'url') {
						// Then add a framekiller test as well
						$content['frametester'] = generateFrametesterUrl($content[$key]);
					} // END - if
				} // END - foreach

				// Finish SQL command
				$sql = substr($sql, 0, -1) . " WHERE `".$idColumn."`=".bigintval($id)." LIMIT 1";

				// Run this query
				SQL_QUERY($sql, __FUNCTION__, __LINE__);

				// Add affected rows
				$affected += SQL_AFFECTEDROWS();

				// Load all data from that id
				$result = SQL_QUERY_ESC("SELECT * FROM `{?_MYSQL_PREFIX?}_%s` WHERE `%s`=%s LIMIT 1",
					array($table, $idColumn, $id), __FUNCTION__, __LINE__);

				// Fetch the data and merge it into $content
				$content = merge_array($content, SQL_FETCHARRAY($result));

				// Free the result
				SQL_FREERESULT($result);

				// Send "build mails" out
				sendAdminBuildMails('edit', $table, $content, $id);
			} // END - foreach

			// Was this fine?
			if ($affected == count($IDs)) {
				// All deleted
				loadTemplate('admin_settings_saved', false, getMessage('ADMIN_ALL_ENTRIES_EDITED'));
			} else {
				// Some are still there :(
				loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_SOME_ENTRIES_NOT_EDITED'), $affected, count($IDs)));
			}
		} else {
			// List for editing
			adminListBuilder('edit', $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}

// Un-/lock rows by given id numbers
function adminLockEntriesConfirm ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $statusArray=array(), $lockNow=false, $idColumn='id', $userIdColumn='userid') {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues)) && (($lockNow === false) || (count($statusArray) == 1))) {
		// Shall we un-/lock here or list for locking?
		if ($lockNow === true) {
			// Un-/lock entries
			adminBuilderStatusHandler("lock", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn, $statusArray);
		} else {
			// List for editing
			adminListBuilder("lock", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}

// Undelete rows by given id numbers
function adminUndeleteEntriesConfirm ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $statusArray=array(), $undeleteNow=false, $idColumn='id', $userIdColumn='userid') {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues)) && (($undeleteNow === false) || (count($statusArray) == 1))) {
		// Shall we un-/lock here or list for locking?
		if ($undeleteNow === true) {
			// Undelete entries
			adminBuilderStatusHandler("undelete", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn, $statusArray);
		} else {
			// List for editing
			adminListBuilder("undelete", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}

// Checks proxy settins by fetching check-updates3.php from www.mxchange.org
function adminTestProxySettings ($settingsArray) {
	// Set temporary the new settings
	mergeConfig($settingsArray);

	// Now get the test URL
	$content = sendGetRequest('check-updates3.php');

	// Is the first line with "200 OK"?
	$valid = (strpos($content[0], '200 OK') !== false);

	// Return result
	return $valid;
}

// Sends out a link to the given email adress so the admin can reset his/her password
function sendAdminPasswordResetLink ($email) {
	// Init output
	$OUT = '';

	// Look up administator login
	$result = SQL_QUERY_ESC("SELECT `id`, `login`, `password` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `email`='%s' LIMIT 1",
		array($email), __FUNCTION__, __LINE__);

	// Is there an account?
	if (SQL_NUMROWS($result) == '0') {
		// No account found!
		return getMessage('ADMIN_NO_LOGIN_WITH_EMAIL');
	} // END - if

	// Load all data
	$content = SQL_FETCHARRAY($result);

	// Free result
	SQL_FREERESULT($result);

	// Generate hash for reset link
	$content['hash'] = generateHash(getConfig('URL').':'.$content['id'].':'.$content['login'].':'.$content['password'], substr($content['password'], 10));

	// Remove some data
	unset($content['id']);
	unset($content['password']);

	// Prepare email
	$mailText = loadEmailTemplate('admin_reset_password', $content);

	// Send it out
	sendEmail($email, getMessage('ADMIN_RESET_PASS_LINK_SUBJ'), $mailText);

	// Prepare output
	return getMessage('ADMIN_RESET_LINK_SENT');
}

// Validate hash and login for password reset
function adminResetValidateHashLogin ($hash, $login) {
	// By default nothing validates... ;)
	$valid = false;

	// Then try to find that user
	$result = SQL_QUERY_ESC("SELECT `id`, `password`, `email` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `login`='%s' LIMIT 1",
		array($login), __FUNCTION__, __LINE__);

	// Is an account here?
	if (SQL_NUMROWS($result) == 1) {
		// Load all data
		$content = SQL_FETCHARRAY($result);

		// Generate hash again
		$hashFromData = generateHash(getConfig('URL') . ':' . $content['id'] . ':' . $login . ':' . $content['password'], substr($content['password'], 10));

		// Does both match?
		$valid = ($hash == $hashFromData);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return result
	return $valid;
}

// Reset the password for the login. Do NOT call this function without calling above function first!
function doResetAdminPassword ($login, $password) {
	// Init hash
	$passHash = '';

	// Now check if we have sql_patches installed
	if (isExtensionInstalledAndNewer('sql_patches', '0.3.6')) {
		// Use new way of hashing
		$passHash = generateHash($password);
	} else {
		// Old MD5 method
		$passHash = md5($password);
	}

	// Update database
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins` SET `password`='%s' WHERE `login`='%s' LIMIT 1",
		array($passHash, $login), __FUNCTION__, __LINE__);

	// Run filters
	runFilterChain('post_admin_reset_pass', array('login' => $login, 'hash' => $passHash));

	// Return output
	return getMessage('ADMIN_PASSWORD_RESET_DONE');
}

// Solves a task by given id number
function adminSolveTask ($id) {
	// Update the task data
	adminUpdateTaskData($id, 'status', 'SOLVED');
}

// Marks a given task as deleted
function adminDeleteTask ($id) {
	// Update the task data
	adminUpdateTaskData($id, 'status', 'DELETED');
}

// Function to update task data
function adminUpdateTaskData ($id, $row, $data) {
	// Should be admin!
	if (!isAdmin()) {
		// Not an admin so redirect better
		redirectToUrl('index.php');
	} // END - if

	// Is the id not set, then we need a backtrace here... :(
	if ($id <= 0) {
		// Initiate backtrace
		debug_report_bug(sprintf("id is invalid: %s. row=%s, data=%s",
			$id,
			$row,
			$data
		));
	} // END - if

	// Update the task
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_task_system` SET `%s`='%s' WHERE `id`=%s LIMIT 1",
		array($row, $data, bigintval($id)), __FUNCTION__, __LINE__);
}

// Checks wether if the admin menu has entries
function ifAdminMenuHasEntries ($action) {
	return (
		((
			isset($GLOBALS['admin_menu_has_entries'][$action])
		) && (
			$GLOBALS['admin_menu_has_entries'][$action] === true
		)) || (
			$action == 'login'
		)
	);
}

// Setter for 'admin_menu_has_entries'
function setAdminMenuHasEntries ($action, $hasEntries) {
	$GLOBALS['admin_menu_has_entries'][$action] = (bool) $hasEntries;
}

// Creates a link to the user's admin-profile
function adminCreateUserLink ($userid) {
	// Is the userid set correctly?
	if ($userid > 0) {
		// Create a link to that profile
		return '{?URL?}/modules.php?module=admin&amp;what=list_user&amp;userid='.bigintval($userid);
	} // END - if

	// Return a link to the user list
	return '{?URL?}/modules.php?module=admin&amp;what=list_user';
}

// Generate a "link" for the given admin id (admin_id)
function generateAdminLink ($adminId) {
	// No assigned admin is default
	$adminLink = "<span class=\"admin_note\">{--ADMIN_NO_ADMIN_ASSIGNED--}</span>";

	// Zero? = Not assigned
	if (bigintval($adminId) > 0) {
		// Load admin's login
		$login = getAdminLogin($adminId);

		// Is the login valid?
		if ($login != '***') {
			// Is the extension there?
			if (isExtensionActive('admins')) {
				// Admin found
				$adminLink = "<a href=\"".generateEmailLink(getAdminEmail($adminId), 'admins')."\">" . $login."</a>";
			} else {
				// Extension not found
				$adminLink = sprintf(getMessage('EXTENSION_PROBLEM_NOT_INSTALLED'), 'admins');
			}
		} else {
			// Maybe deleted?
			$adminLink = "<div class=\"admin_note\">".sprintf(getMessage('ADMIN_ID_404'), $adminId)."</div>";
		}
	} // END - if

	// Return result
	return $adminLink;
}

// [EOF]
?>
