<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/08/2008 *
 * ================                             Last change: 09/08/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-unlock_surfbar_urls.php                     *
 * -------------------------------------------------------------------- *
 * Short description : Unlock pending URLs for surfbar                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Wartende URLs in der Surfbar freigeben           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Is the form sent?
if ((isPostRequestElementSet(('unlock'))) && (is_array(postRequestElement('id'))) && (count(postRequestElement('id')) > 0)) {
	// Unlock selected URLs
	if (SURFBAR_ADMIN_UNLOCK_URL_IDS(postRequestElement('id'))) {
		// Unlock done! :-)
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SURFBAR_UNLOCK_DONE'));
	} else {
		// Unlock failed!
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SURFBAR_UNLOCK_FAILED'));
	}
} elseif ((isPostRequestElementSet(('reject'))) && (is_array(postRequestElement('id'))) && (count(postRequestElement('id')) > 0)) {
	// Reject selected URLs
	if (SURFBAR_ADMIN_REJECT_URL_IDS(postRequestElement('id'))) {
		// Unlock done! :-)
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SURFBAR_UNLOCK_DONE'));
	} else {
		// Unlock failed!
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SURFBAR_UNLOCK_FAILED'));
	}
}

// List all URLs
$result = SQL_QUERY("SELECT
	`id`, `userid`, `url`, UNIX_TIMESTAMP(`registered`) AS registered
FROM
	`{?_MYSQL_PREFIX?}_surfbar_urls`
WHERE
	`status`='PENDING'
ORDER BY
	`id` ASC", __FILE__, __LINE__);

// Do we have some URLs left?
if (SQL_NUMROWS($result) > 0) {
	// List all URLs
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// "Translate"/add content
		$content['sw']          = $SW;
		$content['userid']      = generateUserProfileLink($content['userid']);
		$content['framekiller'] = generateFrametesterUrl($content['url']);
		$content['registered']  = generateDateTime($content['registered'], 2);

		// Load row template
		$OUT .= loadTemplate('admin_unlock_surfbar_urls_row', true, $content);

		// Switch color
		$SW = 3 - $SW;
	} // END - while

	// Load main template
	loadTemplate('admin_unlock_surfbar_urls', false, $OUT);
} else {
	// No URLs in surfbar
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SURFBAR_NO_URLS_FOUND'));
}

// Free result
SQL_FREERESULT($result);

// [EOF]
?>
